#pragma once
#include "VodafoneUSBModem.h"
#include "VodafoneTestCase.h"
#include "Tests.h"
#include <vector>

#define NUMBER_OF_TESTS 100

class TestManager {

   public:
      TestManager(VodafoneUSBModem *m);
      void addTest(VodafoneTestCase *tc);
      
      bool runTest(int id);
      bool runTest(int id, int numTimes);
      int  runTestProfile(TestProfile profile);
      int  getTestProfileLength(TestProfile profile);
      
      
   private:
      VodafoneUSBModem *_modem;
      vector<VodafoneTestCase*> _tests;
      VodafoneTestCase* constructTest(int id);
      int  runTestList(const int *list, const int listLen);
      void listFailures(const int *list, const int listLen);
      void resetTestOutcomes();
      bool *_testOutcomes;
      
};