#pragma once
#include "VodafoneTestCase.h"

extern const char* gTest09Description;

class Test09 : public VodafoneTestCase {
   public: 
      Test09(VodafoneUSBModem *m) : VodafoneTestCase(m) {}
   private:
      
      virtual void setupTest() {
         
      }
   
      virtual bool executeTest() {

         LOG(gTest09Description);
         int rssi = -1000;
         LinkMonitor::REGISTRATION_STATE regState = LinkMonitor::REGISTRATION_STATE_UNKNOWN;
         LinkMonitor::BEARER bearer = LinkMonitor::BEARER_UNKNOWN;
        
         if(_modem->getLinkState(&rssi, &regState, &bearer)==0) {
            if(rssi==-1000) {
               LOG("RSSI: Error.");
               return false;
            } else {
               LOG("RSSI: %d",rssi);
            }
            
            switch(regState) {
               case LinkMonitor::REGISTRATION_STATE_UNKNOWN:
                  LOG("regState: UNKNOWN. Failing.");
                  return false;
               case LinkMonitor::REGISTRATION_STATE_REGISTERING:
                  LOG("regState: REGISTERING");
                  break;
               case LinkMonitor::REGISTRATION_STATE_DENIED:
                  LOG("regState: DENIED");
                  break;
               case LinkMonitor::REGISTRATION_STATE_NO_SIGNAL:
                  LOG("regState: NO SIGNAL");
                  break;
               case LinkMonitor::REGISTRATION_STATE_HOME_NETWORK:
                  LOG("regState: HOME NETWORK");
                  break;
               case LinkMonitor::REGISTRATION_STATE_ROAMING:
                  LOG("regState: ROAMING");
                  break;
               default:
                  LOG("regState: ERROR. Failing.");
                  return false;
            }
            
            switch(bearer) {
               case LinkMonitor::BEARER_UNKNOWN:
                  LOG("bearer: UNKNOWN. Failing.");
                  return false;
               case LinkMonitor::BEARER_GSM:
                  LOG("bearer: GSM");
                  break;
               case LinkMonitor::BEARER_EDGE:
                  LOG("bearer: EDGE");
                  break;
               case LinkMonitor::BEARER_UMTS:
                  LOG("bearer: UMTS");
                  break;
               case LinkMonitor::BEARER_HSPA:
                  LOG("bearer: HSPA");
                  break;
               case LinkMonitor::BEARER_LTE:
                  LOG("bearer: LTE");
                  break;
               default:
                  LOG("bearer: ERROR. Failing.");
                  return false;
            }
            
         } else {
            return false;
         }
         
         return true;
      }
      
      virtual void endTest() {
         
      }
      
};
